###################################################
### chunk number 1: 
###################################################
 options(continue="  ")
 options(warn=1)


###################################################
### chunk number 2: 
###################################################
library("TSfame")  


###################################################
### chunk number 3: 
###################################################
con <- TSconnect("fame", dbname="testvigFame.db") 


###################################################
### chunk number 4: 
###################################################
 z <- ts(rnorm(10), start=c(1990,1), frequency=1)
 seriesNames(z) <- "vec"
 if(TSexists("vec", con)) TSdelete("vec", con) 
 TSput( z, con)
 z <- TSget("vec", con)


###################################################
### chunk number 5: 
###################################################
 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=1)
 seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con)
 TSget("matc1", con)
 TSget("matc2", con)
 TSget(c("matc1","matc2"), con)
 tfplot(z+1, TSget(c("matc1","matc2"), con), 
          lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### chunk number 6: 
###################################################
 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=4)
  seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con)
 TSget(c("matc1","matc2"), con)
 tfplot(z+1, TSget(c("matc1","matc2"), con),
          lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### chunk number 7: 
###################################################
 z <- ts(matrix(rnorm(200),100,2), start=c(1995,1), frequency=12)
  seriesNames(z) <- c("mat2c1", "mat2c2")
 TSreplace(z, con)
 tfplot(z+1, TSget(c("mat2c1","mat2c2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### chunk number 8: 
###################################################
 TSmeta("mat2c1", con)
 TSmeta("vec", con)
 TSdates("vec", con)
 TSdescription("vec", con)
 TSdoc("vec", con)


###################################################
### chunk number 9: 
###################################################
 options(TSconnection=con)


###################################################
### chunk number 10: 
###################################################
 z <- TSget("mat2c1") 
 TSmeta("mat2c1")


###################################################
### chunk number 11: 
###################################################
 z <- ts(matrix(rnorm(10),10,1), start=c(1990,1), frequency=1)
 TSreplace(z, serIDs="Series1", con) 
 zz <- TSget("Series1", con)
 TSreplace(z, serIDs="Series1", con, 
     TSdescription="short rnorm series", 
     TSdoc="Series created as an example in the vignette.")
 zz <- TSget("Series1", con, TSdescription=TRUE, TSdoc=TRUE)
 start(zz)
 end(zz)
 TSdescription(zz)
 TSdoc(zz)

 TSdescription("Series1", con)
 TSdoc("Series1", con)

 z <- ts(rnorm(10), start=c(1990,1), frequency=1)
 seriesNames(z) <- "vec"
 TSreplace(z, con)
 zz <- TSget("vec", con)

 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=1)
 seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con) 
 tfplot(z+1, TSget(c("matc1","matc2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))



###################################################
### chunk number 12: 
###################################################
 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=4)
 seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con)
 tfplot(z+1, TSget(c("matc1","matc2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))



###################################################
### chunk number 13: 
###################################################
 z <- ts(matrix(rnorm(200),100,2), start=c(1995,1), frequency=12)
 seriesNames(z) <- c("mat2c1", "mat2c2")
 TSreplace(z, con) 
 tfplot(z+1, TSget(c("mat2c1","mat2c2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### chunk number 14: 
###################################################
require("zoo") 

 z <- zoo(matrix(rnorm(200),100,2), as.Date("1990-01-01") + 0:99)
  seriesNames(z) <- c("zooc1", "zooc2")
 TSreplace(z, con, Table="D")
 tfplot(z+1, TSget(c("zooc1","zooc2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))
  


###################################################
### chunk number 15: 
###################################################
 z <- zoo(matrix(rnorm(200),100,2), as.Date("1990-01-01") + 0:99 * 7)
  seriesNames(z) <- c("zooWc1", "zooWc2")
 TSreplace(z, con, Table="W")
 tfplot(z+1, TSget(c("zooWc1","zooWc2"), con), col=c("black", "red"),
    lty=c("dashed", "solid"))  


###################################################
### chunk number 16: 
###################################################
 options(TSconnection=NULL)


###################################################
### chunk number 17: 
###################################################
  require("TShistQuote")
  Yahoo <- TSconnect("histQuote", dbname="yahoo") 
  x <- TSget("^gspc", quote = "Close", con=Yahoo)
  plot(x)
  tfplot(x)

  TSrefperiod(x) 
  TSdescription(x) 
  TSdoc(x) 


###################################################
### chunk number 18: 
###################################################
   TSreplace(x,  serIDs="gspc", Table="B", con=con)


###################################################
### chunk number 19: 
###################################################
  TSrefperiod(TSget(serIDs="gspc", con=con)) 
  TSdescription("gspc", con=con) 
  TSdoc("gspc", con=con)
  tfplot(TSget(serIDs="gspc", con=con))


###################################################
### chunk number 20: 
###################################################
   x <- TSget("ibm", quote = c("Close", "Vol"), con=Yahoo)
   TSreplace(x, serIDs=c("ibm.Cl", "ibm.Vol"),  con=con, Table="B",
              TSdescription.=c("IBM Close","IBM  Volume"),
	      TSdoc.= paste(c(
	         "IBM  Close   retrieved on ",
		 "IBM  Volume retrieved  on "), Sys.Date()))

   z <- TSget(serIDs=c("ibm.Cl", "ibm.Vol"), 
             TSdescription=TRUE, TSdoc=TRUE, con=con)
   TSdescription(z)
   TSdoc(z)
   tfplot(z, xlab = TSdoc(z), Title = TSdescription(z))
   tfplot(z, Title="IBM", start="2007-01-01")


###################################################
### chunk number 21: 
###################################################
   Oanda <- TSconnect("histQuote", dbname="oanda") 
   x <- TSget("EUR/USD", start=Sys.Date() - 495, con=Oanda)
   TSreplace(x, serIDs="EURUSD", con=con)


###################################################
### chunk number 22: 
###################################################
   z <- TSget(serIDs="EURUSD",TSdoc=TRUE, TSdescription=TRUE,  con=con)
   tfplot(z, Title = TSdoc(z), ylab=TSdescription(z))
   tfplot(z, Title = "EUR/USD", start="2007-01-01")
   tfplot(z, Title = "EUR/USD", start="2007-03-01")
   tfplot(z, Title = "EUR/USD", start=Sys.Date()-14, end=Sys.Date(),
      xlab = format(Sys.Date(), "%Y"))


###################################################
### chunk number 23: 
###################################################
  dbDisconnect(con)
  dbDisconnect(Yahoo)
  dbDisconnect(Oanda)


###################################################
### chunk number 24:  eval=FALSE
###################################################
##   m <- dbDriver("fame")
##   conets <- try(TSconnect(m, dbname="ets /home/ets/db/etsintoecd.db",
##                   accessMode="read")) 
##   if (!inherits(conets, "try-error")) {
##   
##   options(TSconnection=conets)
## 
##   print(TSmeta("M.SDR.CCUSMA02.ST"))
## 
## z <- getfame("M.SDR.CCUSMA02.ST", "ets /home/ets/db/etsintoecd.db", 
##  save = FALSE, envir = parent.frame(),start = NULL, end = NULL, getDoc = FALSE)
## 
## id <- fameDbOpen("ets /home/ets/db/etsintoecd.db", "read")
## fameWhat(id, "M.SDR.CCUSMA02.ST")
## fameDbClose(id)
## 
##   EXCH.IDs <- t(matrix(c(
##  	"M.SDR.CCUSMA02.ST",	 "SDR/USD exchange rate",
##  	"M.CAN.CCUSMA02.ST",	 "CAN/USD exchange rate",
##  	"M.MEX.CCUSMA02.ST",	 "MEX/USD exchange rate",
##  	"M.JPN.CCUSMA02.ST",	 "JPN/USD exchange rate",
##  	"M.EMU.CCUSMA02.ST",	 "Euro/USD exchange rate",
##  	"M.OTO.CCUSMA02.ST",	 "OECD /USD exchange rate",
##  	"M.G7M.CCUSMA02.ST",	 "G7   /USD exchange rate",
##  	"M.E15.CCUSMA02.ST",	 "Euro 15. /USD exchange rate"
## 	), 2, 8))
## 
##   print(TSdates(EXCH.IDs[,1]))
##   z <- TSdates(EXCH.IDs[,1])
##   print(start(z))
##   print(end(z))
##    
##   tfplot(TSget(serIDs="V122646", conets))
##   }


###################################################
### chunk number 25:  eval=FALSE
###################################################
## if (!inherits(conets, "try-error")) {
##   print(TSdescription(TSget("V122646", TSdescription=TRUE)))
##   print(TSdescription("V122646"))
## 
##   print(TSdoc(TSget("V122646", TSdoc=TRUE)))
##   print(TSdoc("V122646"))
## 
##   tfplot(TSget("V122646", names="V122646", conets))
##   }


###################################################
### chunk number 26:  eval=FALSE
###################################################
## if (!inherits(conets, "try-error")) {
##   z <- TSget("V122646", TSdescription=TRUE)
##   tfplot(z, Title=strsplit(TSdescription(z), ","))
##   }


###################################################
### chunk number 27:  eval=FALSE
###################################################
## if (!inherits(conets, "try-error")) {
##   z <- TSget("SDSP500", TSdescription=TRUE)
##   tfplot(z, Title=TSdescription(z))
##   plot(z)
##   }


###################################################
### chunk number 28:  eval=FALSE
###################################################
## if (!inherits(conets, "try-error")) {
##   z <- TSget(c("DSP500","SDSP500"), TSdescription=TRUE)
##   tfplot(z, xlab=TSdescription(z))
##   }


###################################################
### chunk number 29:  eval=FALSE
###################################################
## if (!inherits(conets, "try-error")) {
##   plot(z)
##   }


###################################################
### chunk number 30:  eval=FALSE
###################################################
## if (!inherits(conets, "try-error")) {
##   ETSgdp    <- annualizedGrowth(aggregate(TSget("V1992067"),
##                    nfrequency=4,FUN=mean), lag=4, names="GDP Y/Y Growth")
##   tfplot(ETSgdp)
##   }  # end if !try-error


###################################################
### chunk number 31:  eval=FALSE
###################################################
##   if (!inherits(conets, "try-error")) {
##   options(TSconnection=NULL)
##   }  # end if try-error


###################################################
### chunk number 32: 
###################################################
dbDisconnect(con)
options(TSconnection=NULL)


